﻿using System.Reflection;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib.IO;
using OpcLabs.BaseLib.OperationModel;
using OpcLabs.BaseLib.OperationModel.Generic;
using OpcLabs.BaseLib.Utilities;
using OpcLabs.DotProlog.Code;
using OpcLabs.DotProlog.InputOutput;
using OpcLabs.DotProlog.Loading;

namespace DotPrologTest.Loading
{
    [TestClass]
    public class LoaderTest
    {
        [TestMethod]
        public void ConsultTest()
        {
            var loader = new Loader();
            var streamLoader = new StreamLoader<IDatabase>(stream =>
            {
                // ReSharper disable once AssignNullToNotNullAttribute
                TextStream textStream = TextStream.Create(InputOutputMode.Read, stream);
                loader.Consult(textStream);// TODO: how are errors reported?
                return ValueResult.Success(loader.Database);
            });

            ValueResult<IDatabase> valueResult = streamLoader.FromManagedResource(UriUtilities.MakeNetResourceUri(
                Assembly.GetExecutingAssembly().FullName,
                "DotPrologTest.Loading.append.pl"));
            Assert.IsTrue(valueResult.Succeeded);
            IDatabase database = valueResult.Value;
            Assert.IsNotNull(database);

            // TODO:
        }
    }
}
