﻿using System.Collections.Generic;
using JetBrains.Annotations;
using OpcLabs.DotProlog.Terms;

namespace OpcLabs.DotProlog.Test
{
    // Deterministic predicates are predicates that must succeed exactly once and, for well behaved predicates, leave no 
    // choicepoints. 
    public class DeterministicPredicateTest : PredicateTest
    {
        #region Public Constructors

        public DeterministicPredicateTest([NotNull] Functor functor) : base(functor)
        {
        }

        public DeterministicPredicateTest([NotNull] string name, int arity) : base(name, arity)
        {
        }

        #endregion



        #region Public Methods

        public void Test([NotNull] IList<Term> arguments)
        {
            TestPredicate(arguments, Success(), "Expected success.");
        }

        public void Test()
        {
            TestPredicate(Success(), "Expected success.");
        }

        public void Test([NotNull] Term arg)
        {
            TestPredicate(arg, Success(), "Expected success.");
        }

        #endregion
    }
}
