﻿using JetBrains.Annotations;
using OpcLabs.BaseLib;
using OpcLabs.BaseLib.LiveBinding;
using OpcLabs.BaseLibFactory.ComponentModel;

namespace OpcLabs.BaseLibFactory.LiveBinding
{
    static public class PointBindingInstances
    {
        //[NotNull]
        //static public PointBinding Instance0 => new PointBinding();

        [NotNull]
        static public PointBinding Instance1 => new PointBinding
        {
            ValueTarget = ValueTargetInstances.Instance1,
            BindingGroup = PointBindingGroupInstances.Instance1,

            ArgumentsPath = "test1.Arguments.Path",
            BindingOperations = PointBindingOperations.ReadAndWrite,
            Point = new Parameters(),
            ReadEventSource = EventSourceInstances.Instance1,
            ReadParameters = new Parameters(),
            SubscribeParameters = new Parameters(),
            UpdateOutputOnFailure = true,
            WriteEventSource = EventSourceInstances.Instance1,
            WriteParameters = new Parameters()
        };

        [NotNull]
        static public PointBinding Instance2 => new PointBinding
        {
            ValueTarget = ValueTargetInstances.Instance1,
            BindingGroup = PointBindingGroupInstances.Instance2,

            ArgumentsPath = "test2.Arguments.Path",
            BindingOperations = PointBindingOperations.ReadAndSubscribe,
            Point = EmptyParameters.Instance,
            ReadEventSource = EventSourceInstances.Instance1,
            ReadParameters = EmptyParameters.Instance,
            SubscribeParameters = EmptyParameters.Instance,
            UpdateOutputOnFailure = false,
            WriteEventSource = EventSourceInstances.Instance1,
            WriteParameters = EmptyParameters.Instance
        };

        // IMPROVE: have more
    }
}
