﻿
using JetBrains.Annotations;

namespace OpcLabs.BaseLibFactory
{
    static public class StringInstances
    {
        [NotNull]
        static public string Alpha => "ABCDEFGHIJabcdefghij";

        [NotNull]
        static public string AlphaNumeric => "0AB1CD2EF3GH4IJ5ab6cd7ef8gh9ij";

        [NotNull]
        static public string Control => "\x01\x1F\a\b\f\n\r\t\v\x7F";

        [NotNull]
        static public string Over256Chars => new string('A', 256 + 1);

        [NotNull]
        static public string Over32768Chars => new string('B', 32768 + 1);

        [NotNull]
        static public string Over65536Chars => new string('C', 65536 + 1);

        [NotNull]
        static public string SingleChar => "A";

        [NotNull]
        static public string Special => ":!\"#$%&'()*+,-./:;<=>?@[\\]\x5E\x5F\x60\x61{|}\x7E ";

        [NotNull]
        static public string Whitespace => "\t \t";

        [NotNull]
        static public string WithNulls => "qwerty\0zxcvb\0asdfg\0";

        [NotNull]
        static public string WithUnicode => "qwerty\0x1234zxcvb\0x4321asdfg\0xABCD";
    }
}
