﻿using JetBrains.Annotations;
using OpcLabs.BaseLib;
using OpcLabs.EasyOpc.UA.Engine;

namespace OpcLabs.EasyOpcFactory.UA
{
    static public class UAEndpointSelectionPolicyInstances
    {
        [NotNull]
        static public UAEndpointSelectionPolicy AllowedMessageSecurityModes_0
            => new UAEndpointSelectionPolicy(0);

        [NotNull]
        static public UAEndpointSelectionPolicy AllowedMessageSecurityModes_1
            => new UAEndpointSelectionPolicy((UAMessageSecurityModes)1);

        [NotNull]
        static public UAEndpointSelectionPolicy AllowedMessageSecurityModes_2
            => new UAEndpointSelectionPolicy((UAMessageSecurityModes)2);

        [NotNull]
        static public UAEndpointSelectionPolicy AllowedMessageSecurityModes_3
            => new UAEndpointSelectionPolicy((UAMessageSecurityModes)3);

        [NotNull]
        static public UAEndpointSelectionPolicy AllowedMessageSecurityModes_4
            => new UAEndpointSelectionPolicy((UAMessageSecurityModes)4);

        [NotNull]
        static public UAEndpointSelectionPolicy AllowedMessageSecurityModes_5
            => new UAEndpointSelectionPolicy((UAMessageSecurityModes)5);

        [NotNull]
        static public UAEndpointSelectionPolicy AllowedMessageSecurityModes_6
            => new UAEndpointSelectionPolicy((UAMessageSecurityModes)6);

        // same as Default
        //[NotNull]
        //static public UAEndpointSelectionPolicy AllowedMessageSecurityModes_7
        //    => new UAEndpointSelectionPolicy((UAMessageSecurityModes)7);

        [NotNull]
        static public UAEndpointSelectionPolicy Instance1 => new UAEndpointSelectionPolicy
        {
            AllowedMessageSecurityModes = UAMessageSecurityModes.SecuritySignAndEncrypt,
            AllowZeroSecurityLevel = false,
            DataEncodingName = "XML",
            EnforceSameSite = true,
            MessageSecurityPreference = Sign.Positive,
            ProtocolName = "TCP",
            RejectObsoleteSecurityPolicies = true,
            RequireAuthentication = true,
            RequireConfidentiality = true,
            RequireIntegrity = true,
            SecurityPolicyUriString = "securityPolicy",
            TransportProfileUriString = "transportProfile"
        };
    }
}
