﻿
using System;
using System.Collections.Generic;
using JetBrains.Annotations;
using OpcLabs.EasyOpc;

namespace OpcLabs.EasyOpcLiveTest.AlarmsAndEvents
{
    // ReSharper disable once InconsistentNaming
    public class OpcLabs_KitEventServer : CommonServer
    {
        public const string ClsidString = "{68BE808F-C895-47BD-A3F0-701CD7ABCB26}";

        public const string ProgId = "OPCLabs.KitEventServer.2";

        public const string VersionIndependentProgId = "OPCLabs.KitEventServer";



        static public class SourceIds
        {
            // ReSharper disable InconsistentNaming
            public const string Regular_1s = "Simulation.Regular (1 s)";
            // ReSharper restore InconsistentNaming
        }

        public class ServerDescriptorsInfo
        {
            public ServerDescriptorsInfo([NotNull] OpcLabs_KitEventServer parent)
            {
                _parent = parent;
            }

            [NotNull]
            public ServerDescriptor WithClsId => new ServerDescriptor(_parent.Location, Guid.Parse(ClsidString));

            [NotNull]
            public ServerDescriptor WithProgId => new ServerDescriptor(_parent.Location, ProgId);

            [NotNull]
            public ServerDescriptor WithVersionIndependentProgId => new ServerDescriptor(_parent.Location, VersionIndependentProgId);

            [NotNull]
            private readonly OpcLabs_KitEventServer _parent;
        }



        public OpcLabs_KitEventServer([NotNull] string location)
            : base(location)
        {
            ServerDescriptors = new ServerDescriptorsInfo(this);
        }



        [NotNull]
        public readonly ServerDescriptorsInfo ServerDescriptors;

        public override IEnumerable<ServerDescriptor> AllServerDescriptors
        {
            get
            {
                yield return ServerDescriptors.WithClsId;
                yield return ServerDescriptors.WithProgId;
                yield return ServerDescriptors.WithVersionIndependentProgId;
            }
        }
    }
}
