using System;
using System.Diagnostics;
using JetBrains.Annotations;
using OpcLabs.EasyOpc.DataAccess;

namespace OpcLabs.EasyOpcLiveTest.DataAccess
{
    // ReSharper disable once InconsistentNaming
    public class IEasyDAClientTestBase
    {
        #region Public Constructors

        public IEasyDAClientTestBase([NotNull] Func<IEasyDAClient> createClientFunc)
        {
            CreateClientFunc = createClientFunc;
        }

        #endregion



        #region Protected Properties

        [NotNull]
        protected Func<IEasyDAClient> CreateClientFunc { get; }

        #endregion



        #region Protected Methods

        [NotNull]
        protected IEasyDAClient CreateClient()
        {
            IEasyDAClient client = CreateClientFunc();
            Debug.Assert(client != null);
            return client;
        }

        #endregion
    }
}
