﻿using System;
using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc;
using OpcLabs.EasyOpc.DataAccess;
using OpcLabs.EasyOpc.OperationModel;

namespace OpcLabs.EasyOpcLiveTest.DataAccess
{
    // ReSharper disable once InconsistentNaming
    public partial class IEasyDAClientTest_BrowseServers : IEasyDAClientTestBase
    {
        public IEasyDAClientTest_BrowseServers([NotNull] Func<IEasyDAClient> createClientFunc)
            : base(createClientFunc)
        {
        }

        [TestCategory("Live")]
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestMethod]
        public void BrowseServersTest()
        {
            IEasyDAClient client = CreateClient();

            ServerElementCollection actualResultDictionary;
            try
            {
                actualResultDictionary = client.BrowseServers("");
            }
            catch (OpcException opcException)
            {
                if (client.SupportedTechnologies == OpcTechnologies.Xml)    // just this one and nothing else
                {
                    Assert.IsInstanceOfType(opcException.InnerException, typeof(NotSupportedException));
                    return;
                }
                throw;
            }

            Assert.IsNotNull(actualResultDictionary);

            //TODO:

        }
    }
}
