﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib.ComponentModel.Linking;
using OpcLabs.BaseLib.Diagnostics;
using OpcLabs.BaseLib.Extensions.Internal;
using OpcLabs.EasyOpc.DataAccess;
using OpcLabs.EasyOpc.DataAccess.LiveMapping;

namespace OpcLabs.EasyOpcLiveTest.Legacy.LiveMapping._Testers
{
    class TypelessMappingTester
    {
        private class TypelessMappingTestClass
        {
            public Int32 Value { get; set; }
        }

        public void Test()
        {
            var clientMapper = new DAClientMapper();
            var target = new TypelessMappingTestClass();

            var memberInfo = target.GetType().GetSingleMember("Value");
            Check.Assert(memberInfo != null);

            const string itemId = LegacyTestDefs.DataAccess.ItemIds.Register_I4;

            clientMapper.DefineMapping(
                new DAClientItemSource(LegacyTestDefs.ProgIds.KitServer, itemId, DADataSource.Cache),
                new DAClientItemMapping(typeof(Int32)),
                new ObjectMemberLinkingTarget(target.GetType(), target, memberInfo));

            const int value = 1256487;
            new EasyDAClient().WriteItemValue(LegacyTestDefs.ProgIds.KitServer, itemId, value);

            target.Value = 999999999;
            clientMapper.Read();
            Assert.AreEqual(value, target.Value);
        }
    }
}
