﻿using System;
using System.Diagnostics.CodeAnalysis;
using JetBrains.Annotations;
using OpcLabs.BaseLib.Diagnostics;
using OpcLabs.EasyOpc.UA.LiveMapping;

namespace OpcLabs.EasyOpcLiveTest.UA.Environment.UASampleServer
{
    [CLSCompliant(false)]
#pragma warning disable 3021
    public class DataNode : UAMappedNode
#pragma warning restore 3021
    {
        [SuppressMessage("Microsoft.Usage", "CA2214:DoNotCallOverridableMethodsInConstructors")]    // caused by Code Contracts
        public DataNode()
        {
            Dynamic = new DynamicNode();
            Static = new StaticNode();
        }

        [NotNull]
        [UANode]
        public DynamicNode Dynamic { get; set; }  // non-nullness by invariant

        [NotNull]
        [UANode]
        public StaticNode Static { get; set; }  // non-nullness by invariant

        [UsedImplicitly]
        private void ObjectInvariant()
        {
            // Auto-implemented properties
            Check.Invariant(Dynamic != null);
            Check.Invariant(Static != null);
        }
    }
}
