﻿using System.Linq;
using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib.Diagnostics;
using OpcLabs.EasyOpc.DataAccess.OperationModel;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcTest.DataAccess.OperationModel
{
    public partial class DAHandleGroupArgumentsTest
    {
        [TestCategory("BinarySerialization")]
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestMethod]
        public void BinarySerializationTest0()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("BinarySerialization")]
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestMethod]
        public void BinarySerializationTest1()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget1());
        }

        [TestCategory("BinarySerialization")]
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestMethod]
        public void BinarySerializationTestArray()
        {
            Tests.BinarySerializationTest(CreateSerializationTargetArray(), SerializationAssertionArray);
        }

        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest0()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest1()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget1());
        }

        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTestArray()
        {
            Tests.XmlSerializationTest(CreateSerializationTargetArray(), SerializationAssertionArray);
        }

        [NotNull]
        private DAHandleGroupArguments CreateSerializationTarget0()
        {
            return new DAHandleGroupArguments();
        }

        [NotNull]
        private DAHandleGroupArguments CreateSerializationTarget1()
        {
            return new DAHandleGroupArguments(-33333, _groupParametersTest.CreateSerializationTarget1());
        }

        [NotNull]
        private DAHandleGroupArguments CreateSerializationTarget2()
        {
            return new DAHandleGroupArguments(-44444, 1001, 11.223344f);
        }

        [NotNull]
        private DAHandleGroupArguments[] CreateSerializationTargetArray()
        {
            return new[] { CreateSerializationTarget0(), CreateSerializationTarget1(), CreateSerializationTarget2() };
        }

        public void SerializationAssertionArray(DAHandleGroupArguments[] target, DAHandleGroupArguments[] actual)
        {
            Check.Assert(target != null);

            Assert.IsNotNull(actual);
            Assert.IsTrue(target.SequenceEqual(actual));
        }

        [NotNull]
        private readonly DAGroupParametersTest _groupParametersTest = new DAGroupParametersTest();
    }
}
