﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib.Collections.Specialized;
using OpcLabs.EasyOpc.UA;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcTest.UA
{
    public partial class EasyUAClientTest
    {
        // ReSharper disable InconsistentNaming

        [TestCategory("OpcUA")]
        [TestMethod]
        public void LicenseInfoTest_Gettable()
        {
            var target = new EasyUAClient();
            StringObjectDictionary licenseInfo = target.LicenseInfo;
            Assert.IsNotNull(licenseInfo);
        }

        [TestCategory("OpcUA")]
        [TestMethod]
        public void LicenseInfoTest_SerialNumber()
        {
            var target = new EasyUAClient();
            StringObjectDictionary licenseInfo = target.LicenseInfo;
            Assert.IsNotNull(licenseInfo);

            AssertUtilities.WriteLine("LicenseInfo:");
            foreach (KeyValuePair<string, object> pair in licenseInfo)
                AssertUtilities.WriteLine($"{pair.Key} -> {pair.Value}");
            AssertUtilities.WriteLine();

            object serialNumberObject = licenseInfo["Multipurpose.SerialNumber"];
            Assert.IsNotNull(serialNumberObject);
            Trace.WriteLine(serialNumberObject);
            Assert.IsInstanceOfType(serialNumberObject, typeof(UInt32));
        }

        // ReSharper disable InconsistentNaming
    }
}
